## hmat-oss 1.0.4

=== CMakeLists.txt ===
#  HMat-OSS (HMatrix library, open source software)
#
#  Copyright (C) 2014-2015 Airbus Group SAS
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#  http://github.com/jeromerobert/hmat-oss

cmake_minimum_required(VERSION 2.8)

# Set CMAKE_BUILD_TYPE to Release by default.
# Must be done before calling project()
if(CMAKE_BUILD_TYPE MATCHES "^CMAKE_BUILD_TYPE$")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
endif()

# Set BUILD_SHARED_LIBS to ON by default.
# Must be done before calling project()
if(BUILD_SHARED_LIBS MATCHES "^BUILD_SHARED_LIBS$")
    if(NOT WIN32)
        # __declspec(dllexport) are missing in hmat so it's currently not possible
        # to build it as a shared library on win32
        set(BUILD_SHARED_LIBS "ON" CACHE BOOL "Build shared libraries." FORCE)
    endif()
endif()

project(hmat-oss C CXX)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/CMake)

if(NOT HMAT_VERSION)
    include(GitVersion)
    git_version(HMAT 1.0.4)
endif()
set(HMAT_SO_VERSION 1)

# Offer the user the choice of overriding the installation directories
set(INSTALL_LIB_DIR     lib${LIB_SUFFIX} CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR     bin              CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include          CACHE PATH "Installation directory for header files")
set(INSTALL_DATA_DIR    share/hmat       CACHE PATH "Installation directory for data files")
set(INSTALL_CMAKE_DIR   ${INSTALL_LIB_DIR}/cmake/hmat CACHE PATH "Installation directory for cmake config files")

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE DATA CMAKE)
    set(var INSTALL_${p}_DIR)
    set(RELATIVE_INSTALL_${p}_DIR ${INSTALL_${p}_DIR})
    if(NOT IS_ABSOLUTE "${${var}}")
        set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
    endif()
endforeach()

# CMake 2.x does not define MSVC when using Intel compiler on Windows, see
# http://public.kitware.com/Bug/view.php?id=14476
if ( WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel" )
  set(WINTEL TRUE)
  set(CMAKE_C_FLAGS "/Qstd=c99 ${CMAKE_C_FLAGS}")
endif()

# ========================
# C
# ========================
include(CheckIncludeFile)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("sys/types.h" HAVE_SYS_TYPES_H)
check_include_file("time.h" HAVE_TIME_H)
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
check_include_file("unistd.h" HAVE_UNISTD_H)

include_directories(${PROJECT_SOURCE_DIR}/include)

# Enable gcc vectorization
function(opt_flag flag)
  if(CMAKE_VERSION VERSION_GREATER 2.8.12)
    include(CheckCCompilerFlag)
    string(MAKE_C_IDENTIFIER ${flag} label)
    check_c_compiler_flag(${flag} ${label})
    if(${label})
       set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${flag}" PARENT_SCOPE)
       set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${flag}" PARENT_SCOPE)
    endif()
  endif()
endfunction()
opt_flag("-ffast-math")
opt_flag("-funsafe-math-optimizations")

# ========================
# SYSTEM & EXTERNAL LIBS
# ========================
set(EXTRA_LIBS "")

include(CheckLibraryExists)

check_library_exists("m" sqrt "" HAVE_LIBM)
if(HAVE_LIBM)
    set(M_LIBRARY m)
endif()

check_library_exists("rt" clock_gettime "" HAVE_LIBRT)
if(HAVE_LIBRT)
    set(RT_LIBRARY rt)
endif()

find_package(OpenMP)
if(OPENMP_FOUND)
    set(HAVE_OMP_H TRUE)
    set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
    set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
    set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
endif()

# MKL
find_package(MKL)
if(MKL_FOUND)
  include_directories(${MKL_INCLUDE_DIRS})
  set(CMAKE_C_FLAGS "${MKL_COMPILER_FLAGS} ${CMAKE_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${MKL_COMPILER_FLAGS} ${CMAKE_CXX_FLAGS}")
endif()

option(USE_DEBIAN_OPENBLAS "On Debian, link to openblas instead of generic blas." ON)
# BLAS/LAPACK
if (NOT MKL_FOUND)
   if(USE_DEBIAN_OPENBLAS)
        get_filename_component(real_blas_path "/usr/lib/libblas.so" REALPATH)
        string(REGEX MATCH "/usr/lib/openblas-base/libblas.so" is_debian_openblas ${real_blas_path})
        if(is_debian_openblas)
            set(BLAS_FOUND ON)
            set(BLAS_LIBRARIES openblas)
            set(CBLAS_INCLUDE_DIRS /usr/include/openblas)
            include_directories(${CBLAS_INCLUDE_DIRS})
            set(LAPACK_LIBRARIES openblas)
            unset(BLAS_LINKER_FLAGS)
        endif()
    endif()
    if(NOT is_debian_openblas)
        # workaround for cmake issue #0009976
        if (CMAKE_VERSION VERSION_LESS 2.8.4)
            enable_language(Fortran)
        endif ()
        find_package(BLAS REQUIRED)
        find_package(LAPACK REQUIRED)
    endif()
    message(STATUS "BLAS_FOUND = ${BLAS_FOUND}")
    message(STATUS "BLAS_LINKER_FLAGS = ${BLAS_LINKER_FLAGS}")
    message(STATUS "BLAS_LIBRARIES = ${BLAS_LIBRARIES}")
    message(STATUS "LAPACK_LIBRARIES = ${LAPACK_LIBRARIES}")
    link_directories(${BLAS_LIBRARY_DIRS})
    include_directories(${BLAS_INCLUDE_DIRS})
    # MKL_INCLUDE_DIRS is written into HMATConfig.cmake, fake it
    set(MKL_INCLUDE_DIRS "${BLAS_INCLUDE_DIRS}")
endif()

# CBLAS
include(CheckFunctionExists)
if (NOT MKL_CBLAS_FOUND)
    if (CMAKE_VERSION VERSION_GREATER 2.8.8)
        include(CMakePushCheckState)
        cmake_push_check_state()
    endif ()
    set(CMAKE_REQUIRED_LIBRARIES ${BLAS_LIBRARIES})
    check_function_exists("openblas_set_num_threads" HAVE_OPENBLAS_SET_NUM_THREADS)
    check_function_exists("goto_get_num_procs" HAVE_GOTO_GET_NUM_PROCS)
    check_function_exists("cblas_dgemm" CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
    if (CMAKE_VERSION VERSION_GREATER 2.8.8)
        cmake_pop_check_state()
    endif ()
endif()
if ((NOT MKL_CBLAS_FOUND) AND (NOT is_debian_openblas))
    # Functions may already be available via MKL or BLAS, but we need cblas.h
    if (CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
        find_path(CBLAS_INCLUDE_DIRS NAMES cblas.h DOC "CBLAS include directory")
        if(CBLAS_INCLUDE_DIRS)
            set(CMAKE_REQUIRED_INCLUDES ${CBLAS_INCLUDE_DIRS})
            include_directories(${CBLAS_INCLUDE_DIRS})
            check_include_file("cblas.h" HAVE_CBLAS_H)
            if (NOT HAVE_CBLAS_H)
                message(FATAL_ERROR "cblas.h not found")
            endif()
        else(CBLAS_INCLUDE_DIRS)
            message(FATAL_ERROR "cblas.h not found")
        endif(CBLAS_INCLUDE_DIRS)
    else (CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
        find_package(CBLAS REQUIRED)
    endif()
endif ()

# ========================
# Configuration file
# ========================
configure_file("${PROJECT_SOURCE_DIR}/CMake/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# ============================
# Generation des bibliotheques
# ============================

# Sources
file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.cpp)
list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp)

link_directories(${PROJECT_BINARY_DIR} ${BLAS_LIBRARY_DIRS})

add_definitions(-D_GNU_SOURCE)
#  We want to enforce assertions even in Release mode
add_definitions(-UNDEBUG)

if (MSVC)
    add_definitions(-D__func__=__FUNCTION__)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif ()

# lib HMAT
if(HMAT_OSS_STATIC AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} STATIC ${HMAT_SOURCES})
    if(BUILD_SHARED_LIBS)
        set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_FLAGS -fPIC)
    endif()
else()
    add_library(${PROJECT_NAME} ${HMAT_SOURCES})
    install(TARGETS ${PROJECT_NAME}
        EXPORT    HMATLibraryDepends
        RUNTIME DESTINATION "${RELATIVE_INSTALL_BIN_DIR}" COMPONENT Runtime
        LIBRARY DESTINATION "${RELATIVE_INSTALL_LIB_DIR}" COMPONENT Runtime
        ARCHIVE DESTINATION "${RELATIVE_INSTALL_LIB_DIR}" COMPONENT Development
    )
endif()
set_target_properties(${PROJECT_NAME} PROPERTIES LINK_FLAGS "${LAPACK_LINKER_FLAGS} ${BLAS_LINKER_FLAGS} ${MPI_LINK_FLAGS}")

if(NOT HMAT_NO_VERSION)
  set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${HMAT_VERSION} SOVERSION ${HMAT_SO_VERSION})
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES INSTALL_NAME_DIR ${INSTALL_LIB_DIR}    )

# LINK_PRIVATE and LINK_PUBLIC keywords were introduced in 2.8.7
if(BUILD_SHARED_LIBS AND CMAKE_VERSION VERSION_GREATER 2.8.6)
    # Programs using hmat do not need to link directly with second level dependencies so we strip them all
    set(_LINK_PRIVATE LINK_PRIVATE)
    set(_LINK_PUBLIC LINK_PUBLIC)
endif()

target_link_libraries(${PROJECT_NAME}
            ${_LINK_PRIVATE}
            ${CBLAS_LIBRARIES}
            ${BLAS_LIBRARIES}
            ${LAPACK_LIBRARIES}
            ${MPI_C_LIBRARIES}
            ${CMAKE_CXX_IMPLICIT_LINK_LIBRARIES})
if(MKL_FOUND)
    # The start-group/end-group flags must be at the end of the
    # link command line, so we must use target_link_libraries not, CMAKE_SHARED_XXX_FLAGS
    target_link_libraries(${PROJECT_NAME} ${_LINK_PRIVATE} ${MKL_LINKER_FLAGS})
endif()

if (HAVE_LIBRT)
    # rt is needed by my_chrono.hpp
    target_link_libraries(${PROJECT_NAME} ${_LINK_PUBLIC} ${RT_LIBRARY})
endif ()

if (HAVE_LIBM)
    target_link_libraries(${PROJECT_NAME} ${_LINK_PUBLIC} ${M_LIBRARY})
endif()

# Examples
include_directories(${PROJECT_SOURCE_DIR}/src)

# Install examples with RPATH
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${INSTALL_LIB_DIR}" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${INSTALL_LIB_DIR}")
endif("${isSystemDir}" STREQUAL "-1")

option(BUILD_EXAMPLES "build examples" OFF)
macro(hmat_add_example name source)
  if (BUILD_EXAMPLES)
    if (MSVC OR WINTEL)
      set_source_files_properties("examples/${source}" PROPERTIES COMPILE_FLAGS "-D_USE_MATH_DEFINES")
    endif ()
    if (MSVC)
      #  No complex.h on MSVC, compile with C++
      set_source_files_properties("examples/${source}" PROPERTIES LANGUAGE CXX)
    endif ()
    add_executable(${HMAT_PREFIX_EXAMPLE}${name} ${PROJECT_SOURCE_DIR}/examples/${source})
    target_link_libraries(${HMAT_PREFIX_EXAMPLE}${name} ${PROJECT_NAME})
    install(TARGETS ${HMAT_PREFIX_EXAMPLE}${name} DESTINATION "${RELATIVE_INSTALL_BIN_DIR}/examples" COMPONENT Runtime)
  endif ()
endmacro()

hmat_add_example(kriging kriging.cpp)
hmat_add_example(cylinder cylinder.cpp)
hmat_add_example(c-cylinder c-cylinder.c)
hmat_add_example(c-simple-cylinder c-simple-cylinder.c)
hmat_add_example(c-simple-kriging c-simple-kriging.c)


install(DIRECTORY include/hmat DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT Development)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/hmat DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT Development)
set(CXX_HMAT_HEADERS "full_matrix;hmat_cpp_interface;compression;h_matrix;"
    "default_engine;cluster_tree;tree;interaction;data_types")
foreach(header ${CXX_HMAT_HEADERS})
    set(HMAT_HEADERS src/${header}.hpp;${HMAT_HEADERS})
endforeach()

=== debian/changelog ===
hmat-oss (1.0.4-2ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 03:34:10 +0000

hmat-oss (1.0.4-2) unstable; urgency=low

  * Upload to unstable (Closes: #775738)

 -- Denis Barbier <barbier@debian.org>  Sun, 25 Jan 2015 11:22:12 +0000

hmat-oss (1.0.4-1) unstable; urgency=low

  * Initial release

 -- Julien Schueller <schueller@phimeca.com>  Sat, 22 Nov 2014 21:39:33 +0100

=== debian/control ===
Source: hmat-oss
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Julien Schueller <schueller@phimeca.com>, Denis Barbier <barbier@debian.org>
Build-Depends: debhelper (>= 8), quilt, cmake, liblapack-dev, libblas-dev
Standards-Version: 3.9.6
Homepage: https://github.com/jeromerobert/hmat-oss
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/hmat-oss.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/hmat-oss.git -b debian/experimental

Package: libhmat-oss1v5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libhmat-oss1
Replaces: libhmat-oss1
Description: dynamic libraries for HMat 
 A hierarchical matrix C/C++ library including a LU solver.

Package: libhmat-oss-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libhmat-oss1v5 (= ${binary:Version}),
 liblapack-dev, libblas-dev
Description: headers and development libraries for HMat
 A hierarchical matrix C/C++ library including a LU solver.
 
Package: libhmat-oss1v5-dbg
Section: debug
Architecture: any
Depends: libhmat-oss1v5 (= ${binary:Version}), ${misc:Depends}
Conflicts: libhmat-oss1-dbg
Replaces: libhmat-oss1-dbg
Description: debug symbols for HMat 
 A hierarchical matrix C/C++ library including a LU solver.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif
$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cflags := $(shell dpkg-buildflags --get CFLAGS) $(cppflags)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS) $(cppflags)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)
ldflags += -Wl,--as-needed

# Explicitly set builddir directory
builddir := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)


%:
	dh $@ --buildsystem=cmake --builddirectory=$(builddir) --with quilt --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
            $(with_tbb) \
            -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
            -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(cflags)' \
            -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(cxxflags)' \
            -DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH=/usr/lib \
            -DINSTALL_INCLUDE_DIR:PATH=/usr/include/hmat \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp

override_dh_strip:
	dh_strip --dbg-package=libhmat-oss1v5-dbg

## hmat-oss 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,10 @@
 #  http://github.com/jeromerobert/hmat-oss
 
 cmake_minimum_required(VERSION 2.8)
+
+if (POLICY CMP0018)
+  cmake_policy (SET CMP0018 OLD)
+endif()
 
 # Set CMAKE_BUILD_TYPE to Release by default.
 # Must be done before calling project()
@@ -43,7 +47,7 @@
 
 if(NOT HMAT_VERSION)
     include(GitVersion)
-    git_version(HMAT 1.0.4)
+    git_version(HMAT 1.2.0)
 endif()
 set(HMAT_SO_VERSION 1)
 
@@ -97,6 +101,17 @@
 opt_flag("-ffast-math")
 opt_flag("-funsafe-math-optimizations")
 
+if(CMAKE_SIZEOF_VOID_P EQUAL 4)
+   set(HMAT_32BITS TRUE)
+endif()
+
+# Warning flags
+
+if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
+  SET(CMAKE_CXX_FLAGS "-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix ${CMAKE_CXX_FLAGS}")
+  SET(CMAKE_C_FLAGS "-Werror -Wall -Wno-sign-compare ${CMAKE_C_FLAGS}")
+endif()
+
 # ========================
 # SYSTEM & EXTERNAL LIBS
 # ========================
@@ -114,12 +129,14 @@
     set(RT_LIBRARY rt)
 endif()
 
-find_package(OpenMP)
-if(OPENMP_FOUND)
-    set(HAVE_OMP_H TRUE)
-    set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
-    set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
-    set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
+option(HMAT_DISABLE_OPENMP "Let HMat disable OpenMP (require OpenMP support)" ON)
+if(HMAT_DISABLE_OPENMP)
+    find_package(OpenMP)
+    if(OPENMP_FOUND)
+        set(CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
+        set(CMAKE_C_FLAGS "${OpenMP_C_FLAGS} ${CMAKE_C_FLAGS}")
+        set(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
+    endif()
 endif()
 
 # MKL
@@ -128,6 +145,16 @@
   include_directories(${MKL_INCLUDE_DIRS})
   set(CMAKE_C_FLAGS "${MKL_COMPILER_FLAGS} ${CMAKE_C_FLAGS}")
   set(CMAKE_CXX_FLAGS "${MKL_COMPILER_FLAGS} ${CMAKE_CXX_FLAGS}")
+endif()
+
+# JeMalloc
+option(HMAT_JEMALLOC "Use jemalloc for matrix blocks allocation." OFF)
+if(HMAT_JEMALLOC)
+    find_package(JeMalloc REQUIRED)
+    if(JEMALLOC_FOUND)
+        set(HAVE_JEMALLOC TRUE)
+        include_directories(${JEMALLOC_INCLUDE_DIR})
+    endif()
 endif()
 
 option(USE_DEBIAN_OPENBLAS "On Debian, link to openblas instead of generic blas." ON)
@@ -184,7 +211,6 @@
         find_path(CBLAS_INCLUDE_DIRS NAMES cblas.h DOC "CBLAS include directory")
         if(CBLAS_INCLUDE_DIRS)
             set(CMAKE_REQUIRED_INCLUDES ${CBLAS_INCLUDE_DIRS})
-            include_directories(${CBLAS_INCLUDE_DIRS})
             check_include_file("cblas.h" HAVE_CBLAS_H)
             if (NOT HAVE_CBLAS_H)
                 message(FATAL_ERROR "cblas.h not found")
@@ -195,13 +221,17 @@
     else (CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
         find_package(CBLAS REQUIRED)
     endif()
+    include_directories(${CBLAS_INCLUDE_DIRS})
 endif ()
 
 # ========================
 # Configuration file
 # ========================
 configure_file("${PROJECT_SOURCE_DIR}/CMake/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
-configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config.h")
+configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config-oss.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config-oss.h")
+if(NOT HMAT_SKIP_CONFIG)
+  configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config.h")
+endif()
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 
 # ============================
@@ -209,24 +239,23 @@
 # ============================
 
 # Sources
-file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.cpp)
-list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp)
+file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.[ch]pp include/*.h)
+list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp src/recursion.cpp) # because it is included in default_engine.cpp
 
 link_directories(${PROJECT_BINARY_DIR} ${BLAS_LIBRARY_DIRS})
 
 add_definitions(-D_GNU_SOURCE)
-#  We want to enforce assertions even in Release mode
-add_definitions(-UNDEBUG)
 
 if (MSVC)
     add_definitions(-D__func__=__FUNCTION__)
     add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+    add_definitions(-DNOMINMAX)
 endif ()
 
 # lib HMAT
 if(HMAT_OSS_STATIC AND BUILD_SHARED_LIBS)
     add_library(${PROJECT_NAME} STATIC ${HMAT_SOURCES})
-    if(BUILD_SHARED_LIBS)
+    if(BUILD_SHARED_LIBS AND NOT WIN32)
         set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_FLAGS -fPIC)
     endif()
 else()
@@ -266,6 +295,10 @@
     target_link_libraries(${PROJECT_NAME} ${_LINK_PRIVATE} ${MKL_LINKER_FLAGS})
 endif()
 
+if(JEMALLOC_FOUND)
+    target_link_libraries(${PROJECT_NAME} ${_LINK_PRIVATE} ${JEMALLOC_LIBRARIES})
+endif()
+
 if (HAVE_LIBRT)
     # rt is needed by my_chrono.hpp
     target_link_libraries(${PROJECT_NAME} ${_LINK_PUBLIC} ${RT_LIBRARY})
@@ -285,32 +318,11 @@
 endif("${isSystemDir}" STREQUAL "-1")
 
 option(BUILD_EXAMPLES "build examples" OFF)
+option(INSTALL_EXAMPLES "install examples" OFF)
+
 macro(hmat_add_example name source)
   if (BUILD_EXAMPLES)
     if (MSVC OR WINTEL)
       set_source_files_properties("examples/${source}" PROPERTIES COMPILE_FLAGS "-D_USE_MATH_DEFINES")
     endif ()
     if (MSVC)
-      #  No complex.h on MSVC, compile with C++
-      set_source_files_properties("examples/${source}" PROPERTIES LANGUAGE CXX)
-    endif ()
-    add_executable(${HMAT_PREFIX_EXAMPLE}${name} ${PROJECT_SOURCE_DIR}/examples/${source})
-    target_link_libraries(${HMAT_PREFIX_EXAMPLE}${name} ${PROJECT_NAME})
-    install(TARGETS ${HMAT_PREFIX_EXAMPLE}${name} DESTINATION "${RELATIVE_INSTALL_BIN_DIR}/examples" COMPONENT Runtime)
-  endif ()
-endmacro()
-
-hmat_add_example(kriging kriging.cpp)
-hmat_add_example(cylinder cylinder.cpp)
-hmat_add_example(c-cylinder c-cylinder.c)
-hmat_add_example(c-simple-cylinder c-simple-cylinder.c)
-hmat_add_example(c-simple-kriging c-simple-kriging.c)
-
-
-install(DIRECTORY include/hmat DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT Development)
-install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/hmat DESTINATION "${INSTALL_INCLUDE_DIR}" COMPONENT Development)
-set(CXX_HMAT_HEADERS "full_matrix;hmat_cpp_interface;compression;h_matrix;"
-    "default_engine;cluster_tree;tree;interaction;data_types")
-foreach(header ${CXX_HMAT_HEADERS})
-    set(HMAT_HEADERS src/${header}.hpp;${HMAT_HEADERS})
-endforeach()

=== debian/changelog ===
hmat-oss (1.2.0-2ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Conflict/Replace/Provide renamed library package.  This change can
      be dropped after the 18.04 release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 00:54:39 -0700

hmat-oss (1.2.0-2) unstable; urgency=medium

  * New patch: 0002-Fix-compilation-on-Linux-32-bits-systems.patch
    Fix compilation on 32bit systems, thanks Jérôme Robert.

 -- Denis Barbier <barbier@debian.org>  Thu, 20 Oct 2016 21:08:08 +0100

hmat-oss (1.2.0-1ubuntu1) zesty; urgency=low

  * Sync from Debian unstable.
  * Revert package rename for g++5 ABI transition, since the affected symbols
    were not part of the ABI; and Provide: the renamed package for
    compatibility.  These changes can be dropped after the 18.04 release.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 20 Oct 2016 01:01:30 -0700

hmat-oss (1.2.0-1) unstable; urgency=low

  * New upstream version
  * This version builds with gcc 6.  (Closes: #831143)
  * New patch: 0001-make-build-reproducible.patch
    Makes builds reproducible.

 -- Denis Barbier <barbier@debian.org>  Wed, 19 Oct 2016 21:20:33 +0100

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$// \
https://github.com/jeromerobert/hmat-oss/tags .*/archive/([\d.]*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## hmat-oss 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 if(NOT HMAT_VERSION)
     include(GitVersion)
-    git_version(HMAT 1.2.0)
+    git_version(HMAT 1.5.0)
 endif()
 set(HMAT_SO_VERSION 1)
 
@@ -105,13 +105,6 @@
    set(HMAT_32BITS TRUE)
 endif()
 
-# Warning flags
-
-if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  SET(CMAKE_CXX_FLAGS "-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix ${CMAKE_CXX_FLAGS}")
-  SET(CMAKE_C_FLAGS "-Werror -Wall -Wno-sign-compare ${CMAKE_C_FLAGS}")
-endif()
-
 # ========================
 # SYSTEM & EXTERNAL LIBS
 # ========================
@@ -156,6 +149,19 @@
         include_directories(${JEMALLOC_INCLUDE_DIR})
     endif()
 endif()
+
+# Context timers
+option(HMAT_CONTEXT "Use context timers." OFF)
+if(HMAT_CONTEXT)
+    message(STATUS "Use context timers")
+    set(HAVE_CONTEXT TRUE)
+endif()
+
+# Build date export through hmat_get_build_date()
+option(HMAT_EXPORT_BUILD_DATE "Hmat exports build date." OFF)
+if(HMAT_EXPORT_BUILD_DATE)
+    message(STATUS "Exports build date")
+endif(HMAT_EXPORT_BUILD_DATE)
 
 option(USE_DEBIAN_OPENBLAS "On Debian, link to openblas instead of generic blas." ON)
 # BLAS/LAPACK
@@ -225,6 +231,16 @@
 endif ()
 
 # ========================
+# Warning flags
+# ========================
+include(CheckCXXCompilerFlag)
+check_cxx_compiler_flag("-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix" HAVE_GCC_WARNING_FLAGS)
+if(HAVE_GCC_WARNING_FLAGS)
+  SET(CMAKE_CXX_FLAGS "-Werror -Wall -Wno-unused-result -Wno-sign-compare -Wno-literal-suffix ${CMAKE_CXX_FLAGS}")
+  SET(CMAKE_C_FLAGS "-Werror -Wall -Wno-sign-compare ${CMAKE_C_FLAGS}")
+endif()
+
+# ========================
 # Configuration file
 # ========================
 configure_file("${PROJECT_SOURCE_DIR}/CMake/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
@@ -240,7 +256,7 @@
 
 # Sources
 file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.[ch]pp include/*.h)
-list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp src/recursion.cpp) # because it is included in default_engine.cpp
+list(REMOVE_ITEM HMAT_SOURCES src/hmat_cpp_interface.cpp src/recursion.cpp) # because it is included in default_engine.cpp (and the other *_engine.cpp) and h_matrix.cpp
 
 link_directories(${PROJECT_BINARY_DIR} ${BLAS_LIBRARY_DIRS})
 
@@ -309,20 +325,3 @@
 endif()
 
 # Examples
-include_directories(${PROJECT_SOURCE_DIR}/src)
-
-# Install examples with RPATH
-list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${INSTALL_LIB_DIR}" isSystemDir)
-if("${isSystemDir}" STREQUAL "-1")
-    set(CMAKE_INSTALL_RPATH "${INSTALL_LIB_DIR}")
-endif("${isSystemDir}" STREQUAL "-1")
-
-option(BUILD_EXAMPLES "build examples" OFF)
-option(INSTALL_EXAMPLES "install examples" OFF)
-
-macro(hmat_add_example name source)
-  if (BUILD_EXAMPLES)
-    if (MSVC OR WINTEL)
-      set_source_files_properties("examples/${source}" PROPERTIES COMPILE_FLAGS "-D_USE_MATH_DEFINES")
-    endif ()
-    if (MSVC)

## hmat-oss 1.7.1

=== CMakeLists.txt ===
#  HMat-OSS (HMatrix library, open source software)
#
#  Copyright (C) 2014-2015 Airbus Group SAS
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#  http://github.com/jeromerobert/hmat-oss

cmake_minimum_required(VERSION 3.13)

# Set CMAKE_BUILD_TYPE to Release by default.
# Must be done before calling project()
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
endif()

# Set BUILD_SHARED_LIBS to ON by default.
# Must be done before calling project()
if(BUILD_SHARED_LIBS MATCHES "^BUILD_SHARED_LIBS$")
    if(NOT WIN32)
        # __declspec(dllexport) are missing in hmat so it's currently not possible
        # to build it as a shared library on win32
        set(BUILD_SHARED_LIBS "ON" CACHE BOOL "Build shared libraries." FORCE)
    endif()
endif()

project(hmat-oss C CXX)

if(POLICY CMP0092)
    cmake_policy(SET CMP0092 NEW) # 3.15: MSVC warning flags are not in CMAKE_<LANG>_FLAGS by default.
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/CMake)

if(NOT HMAT_VERSION)
    include(GitVersion)
    git_version(HMAT 1.7.1)
endif()
set(HMAT_SO_VERSION 2)

if ( WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel" )
    set(WINTEL TRUE)
endif()

# Offer the user the choice of overriding the installation directories
set(HMAT_INSTALL_LIB_DIR     lib${LIB_SUFFIX} CACHE PATH "Installation directory for libraries")
set(HMAT_INSTALL_BIN_DIR     bin              CACHE PATH "Installation directory for executables")
set(HMAT_INSTALL_INCLUDE_DIR include          CACHE PATH "Installation directory for header files")
set(HMAT_INSTALL_DATA_DIR    share/hmat       CACHE PATH "Installation directory for data files")
set(HMAT_INSTALL_CMAKE_DIR   ${HMAT_INSTALL_LIB_DIR}/cmake/hmat CACHE PATH "Installation directory for cmake config files")

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE DATA CMAKE)
    set(var HMAT_INSTALL_${p}_DIR)
    set(HMAT_RELATIVE_INSTALL_${p}_DIR ${HMAT_INSTALL_${p}_DIR} CACHE PATH "Installation path HMAT_INSTALL_${p}_DIR relative to CMAKE_INSTALL_PREFIX")
    mark_as_advanced(HMAT_RELATIVE_INSTALL_${p}_DIR)
    if(NOT IS_ABSOLUTE "${${var}}")
        set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
    endif()
endforeach()

# ========================
# Declare target
# ========================

if(NOT TARGET hmat)
    add_library(hmat)
endif()

# Options which modify the list of source files
option(HMAT_TIMELINE "Enable profiling timeline" OFF)

# Sources
file(GLOB_RECURSE HMAT_SOURCES RELATIVE ${PROJECT_SOURCE_DIR} src/*.[ch]pp include/*.h)
list(REMOVE_ITEM HMAT_SOURCES src/recursion.cpp) # because it is included in h_matrix.cpp
if(NOT HMAT_TIMELINE)
    list(REMOVE_ITEM HMAT_SOURCES src/common/timeline.cpp)
endif()

target_sources(hmat PRIVATE ${HMAT_SOURCES})

if(BUILD_SHARED_LIBS)
    set_target_properties(hmat PROPERTIES DEFINE_SYMBOL HMAT_DLL_EXPORTS)
endif()

target_include_directories(hmat
    PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${HMAT_RELATIVE_INSTALL_INCLUDE_DIR}>)

# ========================
# C
# ========================
include(CheckIncludeFile)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("sys/types.h" HAVE_SYS_TYPES_H)
check_include_file("time.h" HAVE_TIME_H)
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("mach/mach_time.h" HAVE_MACH_MACH_TIME_H)

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(HMAT_32BITS TRUE)
endif()

# ========================
# System & external libs
# ========================
if(NOT WIN32)
    include(CheckLibraryExists)
    check_library_exists("m" sqrt "" HAVE_LIBM)
    if(HAVE_LIBM)
        target_link_libraries(hmat PRIVATE m)
        # Examples will also have to be linked against libm
        set(LIBM_TARGET m)
    endif()

    check_library_exists("rt" clock_gettime "" HAVE_LIBRT)
    if(HAVE_LIBRT)
        # clock_gettime() function is called from src/common/chrono.h
        # and must thus be PUBLIC.
        # FIXME: link is mandatory only for GNU libc < 2.17.
        #        Maybe we can drop this line?
        target_link_libraries(hmat PUBLIC rt)
    endif()
endif(NOT WIN32)

option(HMAT_DISABLE_OPENMP "Let HMat disable OpenMP (require OpenMP support)" ON)
if(HMAT_DISABLE_OPENMP)
    find_package(OpenMP)
    if(OpenMP_FOUND)
        target_compile_options(hmat PRIVATE "$<$<COMPILE_LANGUAGE:CXX>:${OpenMP_CXX_FLAGS}>$<$<COMPILE_LANGUAGE:C>:${OpenMP_C_FLAGS}>")
        target_link_libraries(hmat PRIVATE ${OpenMP_C_LIBRARIES})
    endif()
endif()

# JeMalloc
option(HMAT_JEMALLOC "Use jemalloc for matrix blocks allocation." OFF)
if(HMAT_JEMALLOC)
    find_package(JeMalloc REQUIRED)
    if(JEMALLOC_FOUND)
        set(HAVE_JEMALLOC TRUE)
        target_include_directories(hmat PRIVATE ${JEMALLOC_INCLUDE_DIR})
        target_link_libraries(hmat PRIVATE ${JEMALLOC_LIBRARIES})
    endif()
endif()

# Context timers
option(HMAT_CONTEXT "Use context timers." OFF)
if(HMAT_CONTEXT)
    message(STATUS "Use context timers")
    set(HAVE_CONTEXT TRUE)
endif()

# ========================
# BLAS/MKL
# ========================

find_package(MKL)
if(MKL_FOUND)
    target_compile_options(hmat PRIVATE "$<$<COMPILE_LANGUAGE:CXX>:${MKL_COMPILER_FLAGS}>$<$<COMPILE_LANGUAGE:C>:${MKL_COMPILER_FLAGS}>")
    set(CBLAS_INCLUDE_DIR ${MKL_INCLUDE_DIRS})
    set(CBLAS_LIBRARIES ${MKL_LINKER_FLAGS})
endif()

option(USE_DEBIAN_OPENBLAS "On Debian, link to openblas instead of generic blas." ON)
# BLAS/LAPACK
if (NOT MKL_FOUND)
   if(USE_DEBIAN_OPENBLAS)
        get_filename_component(real_blas_path "/usr/lib/libblas.so" REALPATH)
        string(REGEX MATCH "/usr/lib/openblas-base/libblas.so" is_debian_openblas ${real_blas_path})
        if(is_debian_openblas)
            set(BLAS_FOUND ON)
            set(BLAS_LIBRARIES openblas)
            set(CBLAS_INCLUDE_DIR /usr/include/openblas)
            set(LAPACK_LIBRARIES openblas)
            unset(BLAS_LINKER_FLAGS)
        endif()
    endif()
    if(NOT is_debian_openblas)
        find_package(BLAS REQUIRED)
        find_package(LAPACK REQUIRED)
    endif()
endif()

# CBLAS

# For backward compatibility
if(CBLAS_INCLUDE_DIRS)
    set(CBLAS_INCLUDE_DIR ${CBLAS_INCLUDE_DIRS})
endif()

if (NOT MKL_CBLAS_FOUND)
    include(CMakePushCheckState)
    cmake_push_check_state()
    set(CMAKE_REQUIRED_LIBRARIES ${BLAS_LIBRARIES})
    include(CheckFunctionExists)
    check_function_exists("openblas_set_num_threads" HAVE_OPENBLAS_SET_NUM_THREADS)
    check_function_exists("goto_get_num_procs" HAVE_GOTO_GET_NUM_PROCS)
    check_function_exists("cblas_dgemm" CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
    cmake_pop_check_state()
endif()
if ((NOT MKL_CBLAS_FOUND) AND (NOT is_debian_openblas))
    # Functions may already be available via MKL or BLAS, but we need cblas.h
    if (CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
        find_path(CBLAS_INCLUDE_DIR NAMES cblas.h DOC "CBLAS include directory")
        if(CBLAS_INCLUDE_DIR)
            set(CMAKE_REQUIRED_INCLUDES ${CBLAS_INCLUDE_DIR})
            check_include_file("cblas.h" HAVE_CBLAS_H)
            if (NOT HAVE_CBLAS_H)
                message(FATAL_ERROR "cblas.h not found")
            endif()
        else(CBLAS_INCLUDE_DIR)
            message(FATAL_ERROR "cblas.h not found")
        endif(CBLAS_INCLUDE_DIR)
    else (CHECK_FUNCTION_EXISTS_CBLAS_DGEMM)
        find_package(CBLAS REQUIRED)
    endif()
endif()

target_include_directories(hmat PRIVATE ${CBLAS_INCLUDE_DIR})

if(BUILD_SHARED_LIBS)
    target_link_options(hmat PRIVATE "${LAPACK_LINKER_FLAGS};${BLAS_LINKER_FLAGS}")
else()
    set_target_properties(hmat PROPERTIES STATIC_LIBRARY_OPTIONS "${LAPACK_LINKER_FLAGS};${BLAS_LINKER_FLAGS}")
endif()

target_link_libraries(hmat
    PRIVATE
        ${LAPACK_LIBRARIES}
        ${CBLAS_LIBRARIES}
        ${BLAS_LIBRARIES}
)

# ========================
# Compiler flags
# ========================
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

function(hmat_set_compiler_flags _TARGET_NAME)
    check_cxx_compiler_flag("-Werror -Wall" HAVE_COMPILER_WARNING_FLAGS)
    if(HAVE_COMPILER_WARNING_FLAGS)
        target_compile_options(${_TARGET_NAME} PRIVATE -Werror -Wall)
        foreach(flag -Wno-sign-compare;-Wno-undefined-var-template;-Wno-unused-parameter)
            string(REPLACE "-" "_" varname ${flag})
            check_cxx_compiler_flag("${flag}" CXX${varname})
            if(CXX${varname})
                target_compile_options(${_TARGET_NAME} PRIVATE $<$<COMPILE_LANGUAGE:CXX>:${flag}>)
            endif()
            check_c_compiler_flag("${flag}" C${varname})
            if(C${varname})
                target_compile_options(${_TARGET_NAME} PRIVATE $<$<COMPILE_LANGUAGE:C>:${flag}>)
            endif()
        endforeach()
    endif()
    check_cxx_compiler_flag("/W4" MSVC_COMPILER_WARNING_FLAGS)
    if(MSVC_COMPILER_WARNING_FLAGS)
        target_compile_options(${_TARGET_NAME} PRIVATE /W4 -wd869,1786,2557,3280)
    endif()

    # C99 required for complex numbers
    target_compile_features(${_TARGET_NAME} PRIVATE cxx_std_11;c_std_99)

    if(MSVC OR WINTEL)
        target_compile_definitions(${_TARGET_NAME} PRIVATE __func__=__FUNCTION__;_CRT_SECURE_NO_WARNINGS;NOMINMAX;_USE_MATH_DEFINES)
    endif()
endfunction(hmat_set_compiler_flags)

hmat_set_compiler_flags(hmat)

# Enable gcc vectorization
function(opt_flag flag)
    string(MAKE_C_IDENTIFIER ${flag} label)
    check_c_compiler_flag("${flag}" ${label})
    if(${label})
        target_compile_options(hmat PRIVATE $<$<NOT:$<CONFIG:Debug>>:${flag}>)
    endif()
endfunction()
opt_flag("-ffast-math")
opt_flag("-funsafe-math-optimizations")

# ========================
# Misc
# ========================

# Build date export through hmat_get_build_date()
option(HMAT_EXPORT_BUILD_DATE "Hmat exports build date." OFF)
if(HMAT_EXPORT_BUILD_DATE)
    message(STATUS "Exports build date")
endif()

if(HMAT_EXPORT_BUILD_DATE AND NOT WIN32)
  # Regle pour toujours recompiler les sources contenant __DATE__ et __TIME__
  add_custom_command(COMMAND ${CMAKE_COMMAND} -E touch ${PROJECT_BINARY_DIR}/forcedBuild.tmp
    OUTPUT ${PROJECT_BINARY_DIR}/forcedBuild.tmp)
  set_source_files_properties( src/c_default_interface.cpp PROPERTIES OBJECT_DEPENDS ${PROJECT_BINARY_DIR}/forcedBuild.tmp)
endif(HMAT_EXPORT_BUILD_DATE AND NOT WIN32)

if(NOT HMAT_NO_VERSION)
  set_target_properties(hmat PROPERTIES VERSION ${HMAT_VERSION} SOVERSION ${HMAT_SO_VERSION})
endif()

set_target_properties(hmat PROPERTIES INSTALL_NAME_DIR ${HMAT_INSTALL_LIB_DIR})

# ========================
# Configuration file
# ========================
if(NOT BUILD_SHARED_LIBS)
    set(HMAT_STATIC ON)
endif()

configure_file("${PROJECT_SOURCE_DIR}/CMake/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
configure_file("${PROJECT_SOURCE_DIR}/CMake/hmat-config-oss.h.in" "${CMAKE_CURRENT_BINARY_DIR}/hmat/config-oss.h")
if(NOT HMAT_SKIP_CONFIG)

=== debian/changelog ===
hmat-oss (1.7.1-3) unstable; urgency=medium

  * Solving issues that has the package FTBFS with g++-12:
    - incorrect precedence of + and ?: operators
    - unitialization error due to conditional initialization of an array
    (Closes: #1012945)
  * Raising Standards version to 4.6.1 (no change)
  * Marking the shared lib package as Multi-Arch: same

 -- Pierre Gruet <pgt@debian.org>  Sun, 19 Jun 2022 15:14:35 +0200

hmat-oss (1.7.1-2) unstable; urgency=medium

  * Upload to unstable to start the transition auto-hmat-oss
  * Making the autopkgtests depend on build-essential rather than gcc

 -- Pierre Gruet <pgt@debian.org>  Tue, 19 Apr 2022 15:08:33 +0200

hmat-oss (1.7.1-1) experimental; urgency=medium

  * New upstream version 1.7.1
  * Depending on debhelper-compat 13
  * Correcting d/watch, and upgrading it to version 4
  * Performing a SONAME bump, due to non backward-compatible ABI changes
  * Providing descriptions of packages with a bit more details
  * Adding myself as uploader
  * Simplifying debian/gbp.conf
  * Raising Standards version to 4.6.0:
    - Providing https Salsa links in Vcs-* fields
    - Extra priority is now optional
    - Using https form of format URL in d/copyright
    - Rules-Requires-Root: no
    - Dropping old-fashioned -dbg package
  * Removing all upstreamed patches
  * Removing build-dependency on quilt
  * Removing useless dependencies of the -dev package
  * Reworking d/rules:
    - Lighter override of dh_auto_configure
    - No tweaking of DEB_BUILD_OPTIONS
    - Hardening using /usr/share/dpkg/buildflags.mk
  * Refreshing d/copyright
  * Installing the library in /usr/lib/triplet
  * Correcting a spelling error in the source
  * Adding a Lintian override for not providing a symbols file
  * Adding an autopkgtest and providing it as example in the -dev package
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Pierre Gruet <pgt@debian.org>  Sat, 02 Apr 2022 20:44:55 +0200

hmat-oss (1.2.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with glibc 2.33. (Closes: #1002167)

 -- Adrian Bunk <bunk@debian.org>  Wed, 19 Jan 2022 18:14:34 +0200

hmat-oss (1.2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS. (Closes: #897768)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 02 May 2020 00:18:14 +0100

=== debian/control ===
Source: hmat-oss
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Julien Schueller <schueller@phimeca.com>,
           Denis Barbier <barbier@debian.org>,
           Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libblas-dev,
               liblapack-dev
Standards-Version: 4.6.1
Homepage: https://github.com/jeromerobert/hmat-oss
Vcs-Browser: https://salsa.debian.org/science-team/hmat-oss
Vcs-Git: https://salsa.debian.org/science-team/hmat-oss.git
Rules-Requires-Root: no

Package: libhmat-oss2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: hierarchical matrix C/C++ library (shared library)
 This library allows one to compute hierarchical matrices, which are tools from
 numerical mathematics used to approximate non-sparse matrices.
 .
 The implementation uses lower-upper (LU) decompositions.
 .
 This package contains the shared library.

Package: libhmat-oss-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libhmat-oss2 (= ${binary:Version})
Description: hierarchical matrix C/C++ library (development files)
 This library allows one to compute hierarchical matrices, which are tools from
 numerical mathematics used to approximate non-sparse matrices.
 .
 The implementation uses lower-upper (LU) decompositions.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_LIBRARY_ARCHITECTURE:STRING="$(DEB_HOST_MULTIARCH)"
